EDIT - bug #7578

preseve null values in all mesurements during serialization of webservice responses
07/23/2018 01:08 PM - Andreas Kohlbecker

Status: Closed Start date:

Priority: New Due date:

Assignee: Andreas Kohlbecker % Done: 100%
Category: cdmlib-remote Estimated time: 0:00 hour
Target version: Release 5.2

Severity: normal Found in Version:

Description

as reported in #6563 the double values which are null are serialized as 0.0 by json-lib this is plain wrong for all measurments like
those in GatheringEvent

This affect the following model class properties:
Double and Float:

e |ocation.Point.java (3 matches)
o 70: private Double longitude;
o 75: private Double latitude;
o 382: private Double toDecimal(){
molecular.Amplification.java (3 matches)
o 150: private Double electrophoresisVoltage;
o 156: private Double gelRunningTime;
o 162: private Double gelConcentration;
molecular.AmplificationResult.java
o 143:// private Double gelRunningTime;
molecular.DnaQuality.java (3 matches)
o 93: private Double ratioOfAbsorbance260_230;
o 95: private Double ratioOfAbsorbance260_280;
o 97: private Double concentration;
e occurrence.GatheringEvent.java (4 matches)
o 153: private Double distanceToGround;
o 159: private Double distanceToGroundMax;
o 179: private Double distanceToWaterSurface;
o 185: private Double distanceToWaterSurfaceMax;
¢ PreservationMethod.java
o 71: private Double temperature;

description.StatisticalMeasurementValue.java
o 62: private float value;

Integer

¢ description.FeatureNode.java
o 120:-private-tntegersortindex; - value not used
e description.PolytomousKeyNode.java (2 matches)
o 190:privatetntegersertdndex=—1 - value not used
o 237: private Integer nodeNumber = null;
¢ description.QuantitativeData.java
o %w;a{e#ﬁegepsamp}e%e_; i i :
locationPoint.java
o 83: private Integer errorRadius = 0; - 0 by default, can be set to null in which case serialization as null would be ok
media.ExternalLink.java
o 97: private Integer size; - can be null and should be serialized as null in this case
media.MediaRepresentationPart.java
o 61: private Integer size; - should be serialized as null is size is unknown molecular.SequenceString.java
o 56: private Integer length; - should be serialized as null is length is unknown
molecular.SingleReadAlignment.java (3 matches)
o B67: private Integer firstSegPosition; - null serialization ok
o 69: private Integer leftCutPosition; - null serialization ok
o 71: private Integer rightCutPosition; - null serialization ok
e name.TaxonName.java (2 matches)
o 564: private Integer publicationYear; - null serialization ok
o 570: private Integer originalPublicationYear; - null serialization ok
¢ occurrence.GatheringEvent.java (2 matches)
o 127: private Integer absoluteElevation; - null serialization ok
o 133: private Integer absoluteElevationMax; - null serialization ok
e taxon.TaxonNode.java
o 145: private Integer sortindex = -1; -- for internal use only not expected to be null at any time

according to the above analysis all Integer, Double and Float values should be serialized as null if the value is null.

Associated revisions

Revision d9f51acb - 07/24/2018 02:38 PM - Andreas Kohlbecker

fix #7578 DefaultValueProcessor to serialize all null numbers as null

Revision 200979f6 - 08/17/2018 01:26 PM - Andreas Kohlbecker

ref #7578 adding missing json config entry for the generic api

History

#1 - 07/23/2018 01:29 PM - Andreas Kohlbecker

- Description updated

#2 - 07/24/2018 02:38 PM - Andreas Kohlbecker
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|d9f51acb041832197601f3343f4d3f6{d777b888.

#3 - 07/24/2018 02:41 PM - Andreas Kohlbecker

review by checking the example record here:

http://test.e-taxonomy.eu/dataportal/preview/cichorieae/cdm_dataportal/taxon/1ad7630a-290b-464f-99e3-43c9dfb3c38b/specimens but this may be
overwritten by importing a new production DB to test.

#4 - 08/10/2018 09:48 PM - Andreas Miiller

- Subject changed from preseve null values in all mesurements during serializazion of webservice responses to preseve null values in all mesurements
during serialization of webservice responses

#5 - 08/17/2018 12:50 PM - Andreas Kohlbecker

- Status changed from Resolved to In Progress

this seems to be not working as expected:

http://test.e-taxonomy.eu/cdmserver/cichorieae/occurrence/8eaf2ade-d478-4af6-b3df-bad69f23ea3a/gatheringEvent.json

returns '0' for absoluteElevation even if set to NULL

#6 - 08/17/2018 02:09 PM - Andreas Kohlbecker
- Status changed from In Progress to Closed

- % Done changed from 50 to 100

works now!

#7 - 08/17/2018 03:14 PM - Andreas Miuller
error radius still returns 0 in http:/test.e-taxonomy.eu/cdmserver/cichorieae/occurrence/8eaf2ade-d478-4af6-b3df-bad69f23ea3a/gatheringEvent.json

Is this wanted or excepted behavior?

#8 - 08/17/2018 10:01 PM - Andreas Kohlbecker

Andreas Muller wrote:
error radius still returns 0 in
http://test.e-taxonomy.eu/cdmserver/cichorieae/occurrence/8eaf2ade-d478-4af6-b3df-bad69f23ea3a/gatheringEvent.json

Is this wanted or excepted behavior?

The actual value of radius in this case is 0 when | set it to NULL the webservice returns NULL

It seems as if there is a problem with the embedded type Point. Whenever long and lat are set the radius is always set to 0 implying a precision of the
location information which was not intended. It should be NULL instead.
